
# line 58 "gram.y"
#include <stdio.h>
#include "scanner.h"
#include "generic-rel.h"
#include "builtin-syms.h"
#include "parse-utils.h"
#include "profile.h"
#include "annotations.h"
#include "interp.h"

EXTERN int yylex();
EXTERN int yyparse();

ParserStruct parserStruct ;
ExecutionEnv exEnv ;
ParserEnv parseEnv;

// No. of evaluable functors in the lhs of a clause
// that were converted into literals by create_functor.
// (We want to evaluate these *after* the true rhs literals.)
static char *fname = "yyparse" ;
static  Clause *cur_rule;
static BitVector CurTail;
static BitVector CurBoundVars;
extern void COR_set_single_answer(ModuleInfo& Module, int val);

//DontCareArg TheParameterArg;
Arg_t *TheParameterArg;

const Symbol ** builtin_ops[] = {
    // Aggregation operators: These must be FIRST, and in the same
    // ORDER as in the enum AggregateKind (defined in arg.h). 
    &SumOpSymbol,
    &ProdOpSymbol,
    &CountOpSymbol,
    &MinOpSymbol,
    &MaxOpSymbol,
    &AvgOpSymbol,
    &SDstOpSymbol,
    &PDstOpSymbol,
    &CDstOpSymbol,
    &ADstOpSymbol,
    &DstOpSymbol,
    &AnyOpSymbol,

    /** Normal (not aggregation) operators: **/
    /** Builtin_Arith_Start = 12 **/
    &LssOpSymbol,
    &GrtOpSymbol,
    &LeqOpSymbol,
    &GeqOpSymbol,
    /** Builtin_Convertible_Start = 16 **/
    &AddOpSymbol,
    &SubOpSymbol,
    &MulOpSymbol,
    &DivOpSymbol,
    &IDivOpSymbol,

    &LShiftOpSymbol,
    &RShiftOpSymbol,
    &BitxorOpSymbol,
    &BitandOpSymbol,
    &BitorOpSymbol,
    &BitnotOpSymbol,
    &ModOpSymbol,

    0
};

struct SymbolTable * BuiltinRelTable ;
int Builtin_Arith_Start = 12 ;
int Builtin_Convertible_Start = 16 ;


int C_num_head_arith_lits;   /* Number of arithmetic literals introduced in
				converting arithmetic functions in the head
				literal.  These need to be moved to the end
				of the rule later */

int complexRelation = 0; /* used only for set grouping */

int in_bulk_load = 0;

# define APPEND 257
# define UPDATE 258
# define ASSIGN 259
# define DELETE 260
# define MARK 261
# define LPAREN 262
# define RPAREN 263
# define COMMA 264
# define COLON 265
# define SLASHSLASH 266
# define PERIOD 267
# define LBRACE 268
# define RBRACE 269
# define ARROW 270
# define SIPS 271
# define LBRACKET 272
# define RBRACKET 273
# define UNDERSCORE 274
# define VBAR 275
# define PERCENT 276
# define NOT 277
# define QUESTION 278
# define DOLLAR 279
# define TRUE 280
# define SUM 281
# define PROD 282
# define COUNT 283
# define MIN 284
# define MAX 285
# define AVG 286
# define ANY 287
# define DISTINCT 288
# define COUNT_D 289
# define SUM_D 290
# define PROD_D 291
# define AVG_D 292
# define DEL 293
# define START_C_MODULE 294
# define END_C_MODULE 295
# define MODULE 296
# define EXPORT 297
# define ALIAS 298
# define END_MODULE 299
# define PLUS 300
# define MINUS 301
# define STAR 302
# define SLASH 303
# define EQUAL 304
# define NOTEQUAL 305
# define LESS 306
# define GREATER 307
# define LESSEQUAL 308
# define GREATEREQUAL 309
# define LSHIFT 310
# define RSHIFT 311
# define BITXOR 312
# define BITAND 313
# define BITNOT 314
# define BITOR 315
# define MOD 316
# define AT 317
# define CUT 318
# define SYMBOL 319
# define VAR 320
# define OP 321
# define RELOP 322
# define NUM 323
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
YYSTYPE yylval, yyval;
# define YYERRCODE 256

# line 1161 "gram.y"


void yyerror(char *s)
{
 fprintf(exEnv.error_file, "%s line %d:\n", s, parseEnv.C_linenum);
 if (exEnv.C_interrupt_raised > 0) {
   fprintf(exEnv.error_file,
	   "CORAL:: Interrupt occurred during execution!:");
   fprintf(exEnv.error_file, "resetting state !\n");
   fprintf(exEnv.error_file, "Type a period to continue.\n");
   fflush(exEnv.error_file);
   // abort a consult that is halfway thru
   parseEnv.abort_file();
   exEnv.C_interrupt_raised = 0;
  }
}
int yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
-1, 3,
	0, 2,
	-2, 3,
-1, 4,
	293, 18,
	319, 18,
	320, 18,
	-2, 0,
-1, 19,
	268, 97,
	-2, 52,
-1, 20,
	268, 97,
	-2, 52,
-1, 21,
	268, 97,
	-2, 52,
-1, 22,
	268, 97,
	-2, 52,
-1, 23,
	268, 97,
	-2, 52,
-1, 25,
	268, 97,
	-2, 52,
-1, 42,
	262, 103,
	265, 103,
	301, 103,
	-2, 13,
-1, 50,
	273, 70,
	-2, 97,
-1, 57,
	264, 54,
	267, 54,
	298, 54,
	-2, 88,
-1, 78,
	293, 18,
	319, 18,
	320, 18,
	-2, 0,
-1, 82,
	268, 97,
	-2, 70,
-1, 84,
	273, 70,
	-2, 97,
-1, 85,
	268, 97,
	-2, 70,
-1, 92,
	268, 97,
	-2, 102,
-1, 94,
	268, 97,
	-2, 52,
-1, 96,
	268, 97,
	-2, 70,
-1, 116,
	264, 58,
	267, 58,
	298, 58,
	-2, 88,
-1, 125,
	273, 70,
	-2, 97,
-1, 136,
	268, 97,
	-2, 70,
-1, 162,
	268, 97,
	-2, 70,
-1, 170,
	268, 97,
	-2, 70,
-1, 183,
	264, 53,
	267, 53,
	298, 53,
	-2, 93,
-1, 201,
	264, 57,
	267, 57,
	298, 57,
	-2, 93,
-1, 205,
	262, 103,
	-2, 126,
-1, 210,
	273, 70,
	-2, 97,
-1, 215,
	268, 97,
	-2, 70,
-1, 220,
	268, 97,
	-2, 70,
-1, 225,
	270, 120,
	-2, 103,
-1, 226,
	270, 121,
	-2, 89,
-1, 227,
	270, 122,
	-2, 99,
-1, 228,
	270, 123,
	-2, 91,
-1, 230,
	273, 70,
	-2, 97,
-1, 239,
	268, 97,
	-2, 70,
-1, 245,
	268, 97,
	-2, 70,
-1, 262,
	273, 70,
	-2, 97,
-1, 265,
	270, 125,
	-2, 95,
-1, 272,
	268, 97,
	-2, 70,
-1, 274,
	270, 124,
	-2, 93,
	};
# define YYNPROD 154
# define YYLAST 620
int yyact[]={

    65,   250,   215,    43,    31,    30,    76,    77,    76,    77,
    50,    65,    48,   298,   199,    59,    43,    49,    31,    35,
   142,    50,   297,    48,    79,    31,    65,    74,    49,    42,
    30,    76,    77,    94,   285,   276,   230,   291,   228,    63,
    76,    77,    42,    49,    51,   281,   290,    31,    30,   265,
    63,   242,    62,   241,   102,    51,    60,    31,    53,    31,
    80,    46,   198,    62,    65,    63,   189,    95,    31,    53,
    51,   186,    46,   102,    50,   139,    48,   170,    62,   175,
   210,    49,   208,   225,   227,   141,   140,   226,    98,    99,
   100,   101,   109,   110,   111,   112,   113,   114,   103,   104,
   105,   106,   277,   107,   108,    50,   267,    48,    51,   100,
   101,   262,    49,   260,   233,    76,    77,   283,    75,    38,
   211,    31,    53,   108,   248,    46,   282,   205,   207,   102,
    28,   206,   235,   247,    85,   102,   191,    85,   182,    51,
   180,   234,   127,   163,   125,   179,   102,    84,   292,   244,
    92,    94,    31,    53,   124,   287,    46,    33,   225,   259,
    34,   278,   258,    98,    99,   100,   101,   102,   268,    98,
    99,   100,   101,   103,   104,   105,   106,   254,   107,   108,
    98,    99,   100,   101,   102,   108,   237,   187,   102,   131,
   103,   104,   105,   106,   167,   107,   108,   166,    87,   165,
   164,    98,    99,   100,   101,   145,   128,   102,   243,    71,
    36,   103,   104,   105,   106,    15,   107,   108,    98,    99,
   100,   101,    98,    99,   100,   101,    14,    32,   103,   104,
   105,   106,   103,   104,   108,   106,    27,     7,   108,    26,
   203,    98,    99,   100,   101,   169,   139,   171,    89,   299,
   300,   103,   104,     8,     9,    10,    17,   108,    11,    29,
    81,   288,   274,   271,   256,    40,    45,   253,    57,    57,
    57,    57,    57,   202,    57,   201,    13,   190,   183,   176,
   173,   134,    73,   137,   138,   295,    19,    21,    22,    20,
    23,   217,    83,   272,   245,   148,    24,   239,   220,    82,
   162,    85,   136,    96,   232,   204,   213,   222,   116,   195,
    37,    97,   135,    64,    41,    55,     5,   296,    61,   289,
   214,   216,   284,   301,   168,   197,   293,   212,    40,   200,
   133,    44,    93,   143,    52,   174,   238,    90,   147,    78,
    25,    18,    16,    57,    54,    12,     4,    72,     3,     2,
     1,   224,   223,   251,   193,   214,   194,   181,   126,   249,
   196,   185,   231,    86,   275,    66,    67,    68,    69,   188,
    70,    47,   269,    39,     6,    56,    29,     0,     0,     0,
    40,   117,   118,     0,     0,     0,     0,   251,     0,   279,
   130,     0,     0,     0,     0,   129,   132,   286,     0,   120,
   121,   122,   123,     0,     0,     0,   144,     0,     0,   221,
   146,   286,   294,     0,   236,     0,     0,     0,     0,   240,
     0,     0,     0,     0,     0,     0,     0,   161,     0,   246,
     0,     0,     0,     0,     0,     0,     0,     0,   255,     0,
     0,     0,   172,     0,   264,   209,     0,     0,     0,    29,
     0,   218,     0,     0,     0,     0,     0,    88,     0,   229,
     0,   273,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   280,     0,     0,     0,     0,     0,    58,    58,    58,
    58,    58,    29,    58,    29,     0,     0,     0,     0,     0,
     0,     0,   261,   209,   192,     0,     0,     0,     0,     0,
     0,     0,   218,     0,     0,     0,     0,     0,     0,    91,
     0,     0,     0,   219,     0,     0,    29,   115,     0,     0,
     0,     0,     0,   119,     0,     0,    29,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    29,    29,   252,    86,     0,   270,     0,     0,     0,     0,
   263,   257,    58,   266,     0,   149,   150,   151,   152,   153,
   154,   155,   156,   157,   158,   159,   160,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   177,   178,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   184 };
int yypact[]={

 -1000, -1000, -1000, -1000,   -41, -1000,    29, -1000,   -28,   -31,
  -315,   -40,  -107,  -300, -1000,   -57,  -290,  -167, -1000,  -262,
  -262,  -262,  -262,  -262, -1000,  -262, -1000, -1000,   -58, -1000,
 -1000, -1000, -1000,  -167, -1000,  -292, -1000, -1000,  -241,    -4,
    37, -1000, -1000,  -301, -1000,  -125, -1000, -1000, -1000, -1000,
  -251,  -251,  -118, -1000,  -231, -1000, -1000,    41,  -212,  -251,
 -1000, -1000,  -198,  -198, -1000,  -251,  -231,  -231,  -231,  -231,
  -113, -1000, -1000,  -128,  -130,   -61, -1000, -1000,   -41,  -290,
   -76,  -277,  -251,    40,  -251,  -251,  -189,  -188,   -99,    39,
  -287,   -99,  -167,   -62,  -262, -1000,  -251,  -251,  -251,  -251,
  -251,  -251,  -251,  -251,  -251,  -251,  -251,  -251,  -251, -1000,
 -1000, -1000, -1000, -1000, -1000,  -212,    38, -1000, -1000,  -120,
   -67,   -68,   -70,   -73, -1000,  -251,  -185,  -315, -1000, -1000,
 -1000,  -290, -1000,    37,    17,   -18,  -251,  -194,    16,  -251,
  -251, -1000, -1000,  -124, -1000, -1000, -1000,  -134,    15,   -99,
  -193,  -193, -1000, -1000, -1000,  -131,  -131,   -78,   -59,   -82,
 -1000,  -251,  -251, -1000, -1000, -1000, -1000, -1000,  -202,   -80,
  -251,  -207, -1000, -1000,    14, -1000, -1000,   -99,  -137, -1000,
  -167,  -257, -1000, -1000,   -99,    12, -1000, -1000,    10, -1000,
 -1000, -1000, -1000, -1000,   -24, -1000,  -192, -1000, -1000,  -152,
  -315, -1000,  -260,  -257, -1000, -1000, -1000, -1000, -1000,    36,
  -236,  -158,  -132, -1000, -1000,  -251,   -81,  -269,    35, -1000,
  -251,  -220,  -222,   -56,  -121, -1000, -1000, -1000, -1000,    32,
  -251,  -140, -1000,  -272, -1000,  -315,     4, -1000,   -90,  -251,
     1, -1000, -1000,  -161,  -192,  -251,  -224, -1000,  -166,   -97,
 -1000, -1000, -1000,  -294, -1000,     0, -1000, -1000, -1000, -1000,
 -1000,    31,  -251, -1000,    -1, -1000, -1000,  -315,  -170,  -106,
  -269, -1000,  -251,  -228, -1000,  -147, -1000,  -315, -1000,  -112,
    -2, -1000, -1000,  -170,  -227, -1000, -1000, -1000, -1000, -1000,
  -122,  -315,  -315, -1000,    23,  -307,   -14, -1000, -1000, -1000,
  -307, -1000 };
int yypgo[]={

     0,   375,   310,   374,   373,   314,   457,   313,   318,   371,
   291,    35,   364,   362,   304,   119,   248,   311,   360,   359,
   358,   357,   309,   356,   332,   354,   352,   307,   351,   305,
   118,   350,   349,   348,   346,   316,   198,   345,   342,   341,
   344,   340,   339,   338,   315,   312,   337,   334,   333,   329,
   327,   306,   325,   322,   317,    22,    34 };
int yyr1[]={

     0,    32,    31,    34,    33,    33,     2,     2,     2,     4,
     4,     5,     5,     5,    37,    37,    37,    37,    38,     3,
    35,    35,    35,    35,    35,    41,    35,    35,    35,    35,
    35,    35,    35,    35,    35,    35,    35,    35,    35,    42,
    35,    30,    30,    30,    39,    39,    43,    24,    24,    40,
    40,    44,    44,     1,     1,     1,     1,     1,     1,     1,
    17,    17,    17,    17,    17,    17,    45,    45,    46,    36,
    36,     6,     6,     6,     6,     6,     6,     6,     6,     6,
     6,     6,     6,     6,     6,     8,     8,    10,     7,     7,
     7,     7,     7,     7,     7,     7,     7,    47,     7,     9,
    48,    48,    48,    16,    49,    21,    51,    50,    50,    50,
    25,    23,    23,    23,    22,    22,    18,    26,    27,    27,
    28,    28,    28,    28,    28,    28,    29,    29,    29,    29,
    29,    29,    29,    52,    14,    13,    13,    13,    20,    20,
    19,    12,    12,    11,    11,    55,    55,    54,    54,    56,
    53,    53,    15,    15 };
int yyr2[]={

     0,     1,     5,     1,     7,     0,     7,     9,     3,     7,
     3,     9,    11,     3,     5,     7,    11,    13,     1,     5,
     5,    11,    11,    11,    11,     1,     9,     5,     5,     7,
     5,     4,    13,    25,    19,    27,    21,     9,     3,     1,
     9,     3,     3,     1,     9,     3,     1,     9,     1,     6,
     2,     3,     0,     9,     3,     7,     9,    11,     5,     3,
     3,     3,     3,     3,     3,     3,     7,     3,     3,     2,
     1,     2,     7,     7,     7,     7,     7,     7,     7,     7,
     7,     7,     5,     7,     5,     2,     7,     9,     3,     2,
     3,     3,     3,     9,    11,     7,     7,     1,     9,     3,
     7,     3,     0,     2,     1,     9,     3,     6,     2,     0,
     3,     7,     3,     1,     5,     3,     2,     7,     7,     3,
     3,     3,     3,     3,     9,     7,     3,     3,     3,     3,
     9,     7,     7,     9,    11,     7,     3,     5,     1,     7,
     3,     7,     3,    17,     1,     3,     0,     6,     2,     3,
     6,     2,     2,     2 };
int yychk[]={

 -1000,   -31,   -32,   -33,   -34,   -35,    -3,   278,   294,   295,
   296,   299,   -37,   317,   267,   256,   -38,   297,   -39,   257,
   260,   258,   259,   261,   267,   -41,   267,   267,   -15,   -16,
   320,   319,   267,   264,   267,   319,   267,    -2,   -15,    -4,
   -16,    -5,   319,   293,    -7,   -16,   323,    -9,   274,   279,
   272,   306,   -47,   320,   -40,   -44,    -1,   -16,    -6,   277,
   318,    -8,   314,   301,    -7,   262,   -40,   -40,   -40,   -40,
   -40,   267,    -7,   -16,   319,   -30,   300,   301,   -42,   265,
   301,   264,   262,   -16,   272,   262,   -45,   -36,    -6,   -16,
   -46,    -6,   268,   -24,   264,   298,   262,   -17,   300,   301,
   302,   303,   266,   310,   311,   312,   313,   315,   316,   304,
   305,   306,   307,   308,   309,    -6,   -16,    -8,    -8,    -6,
   -24,   -24,   -24,   -24,   267,   272,   -20,   272,   267,   -35,
    -2,   265,    -5,   -16,   -36,   -45,   262,   -36,   -36,   264,
   275,   273,   307,   -48,    -7,   267,   -44,   -43,   -36,    -6,
    -6,    -6,    -6,    -6,    -6,    -6,    -6,    -6,    -6,    -6,
    -6,   -17,   262,   263,   267,   267,   267,   267,   -36,   -30,
   262,   -15,    -2,   263,   -36,   273,   263,    -6,    -6,   269,
   264,   -21,   272,   263,    -6,   -36,   273,   267,   -36,   273,
   263,   273,    -7,   -25,   -23,   -22,   -18,   -52,   319,   271,
   -49,   263,   263,   264,   -29,   319,   323,   320,   274,   -16,
   272,   272,   -50,   -51,   -15,   262,   -30,   -10,   -16,   -22,
   262,   -36,   -27,   -26,   -28,   319,   323,   320,   274,   -16,
   272,   -13,   -14,   272,   273,   264,   -36,   267,   -30,   262,
   -36,   273,   273,   264,   270,   262,   -36,   273,   264,   -19,
   273,   -15,   -51,   263,   267,   -36,   263,   -27,   323,   320,
   274,   -16,   272,   -29,   -36,   273,   -14,   272,   265,   -30,
   -10,   263,   262,   -36,   263,   -12,   -11,   272,   267,   -30,
   -36,   273,   273,   264,   -53,   -56,   -15,   267,   263,   -11,
   273,   264,   270,   -56,   -15,   262,   -54,   -55,   320,   263,
   264,   -55 };
int yydef[]={

     1,    -2,     5,    -2,    -2,     4,     0,    25,     0,     0,
     0,     0,     0,     0,    38,     0,     0,    97,    20,    -2,
    -2,    -2,    -2,    -2,    45,    -2,    27,    28,     0,   152,
   153,   103,    30,    97,    31,    43,    39,    19,     0,     8,
   152,    10,    -2,     0,    14,    88,    89,    90,    91,    92,
    -2,    97,     0,    99,    48,    50,    51,    -2,     0,    97,
    59,    71,    97,    97,    85,    97,    48,    48,    48,    48,
     0,    29,    15,    88,   138,     0,    41,    42,    -2,     0,
     0,     0,    -2,     0,    -2,    -2,    69,     0,    67,    88,
     0,    68,    -2,     0,    -2,    46,    -2,    97,    97,    97,
    97,    97,    97,    97,    97,    97,    97,    97,    97,    60,
    61,    62,    63,    64,    65,     0,    -2,    82,    84,     0,
     0,     0,     0,     0,    26,    -2,    43,     0,    37,    40,
     6,     0,     9,     0,     0,    69,    -2,     0,     0,    97,
    97,    95,    96,     0,   101,    21,    49,     0,     0,    55,
    72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
    83,    97,    -2,    86,    22,    23,    24,    44,     0,     0,
    -2,     0,     7,    11,     0,    16,    93,    66,     0,    98,
    97,   113,   104,    -2,    56,     0,    17,    32,     0,   139,
    12,    94,   100,    47,   110,   112,     0,   115,   116,     0,
   109,    -2,    43,     0,   114,    -2,   127,   128,   129,     0,
    -2,     0,     0,   108,   106,    -2,     0,    43,     0,   111,
    -2,     0,     0,   119,     0,    -2,    -2,    -2,    -2,    88,
    -2,     0,   136,     0,   105,     0,     0,    34,     0,    -2,
     0,   131,   132,     0,     0,    -2,     0,   133,     0,     0,
   137,   140,   107,    43,    36,     0,   130,   118,   121,   122,
   123,     0,    -2,   117,     0,    -2,   135,     0,   144,     0,
    43,    87,    -2,     0,    -2,     0,   142,     0,    33,     0,
     0,   125,   134,   144,     0,   151,   149,    35,   124,   141,
     0,     0,     0,   150,     0,   146,     0,   148,   145,   143,
   146,   147 };
typedef struct { char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"APPEND",	257,
	"UPDATE",	258,
	"ASSIGN",	259,
	"DELETE",	260,
	"MARK",	261,
	"LPAREN",	262,
	"RPAREN",	263,
	"COMMA",	264,
	"COLON",	265,
	"SLASHSLASH",	266,
	"PERIOD",	267,
	"LBRACE",	268,
	"RBRACE",	269,
	"ARROW",	270,
	"SIPS",	271,
	"LBRACKET",	272,
	"RBRACKET",	273,
	"UNDERSCORE",	274,
	"VBAR",	275,
	"PERCENT",	276,
	"NOT",	277,
	"QUESTION",	278,
	"DOLLAR",	279,
	"TRUE",	280,
	"SUM",	281,
	"PROD",	282,
	"COUNT",	283,
	"MIN",	284,
	"MAX",	285,
	"AVG",	286,
	"ANY",	287,
	"DISTINCT",	288,
	"COUNT_D",	289,
	"SUM_D",	290,
	"PROD_D",	291,
	"AVG_D",	292,
	"DEL",	293,
	"START_C_MODULE",	294,
	"END_C_MODULE",	295,
	"MODULE",	296,
	"EXPORT",	297,
	"ALIAS",	298,
	"END_MODULE",	299,
	"PLUS",	300,
	"MINUS",	301,
	"STAR",	302,
	"SLASH",	303,
	"EQUAL",	304,
	"NOTEQUAL",	305,
	"LESS",	306,
	"GREATER",	307,
	"LESSEQUAL",	308,
	"GREATEREQUAL",	309,
	"LSHIFT",	310,
	"RSHIFT",	311,
	"BITXOR",	312,
	"BITAND",	313,
	"BITNOT",	314,
	"BITOR",	315,
	"MOD",	316,
	"AT",	317,
	"CUT",	318,
	"SYMBOL",	319,
	"VAR",	320,
	"OP",	321,
	"RELOP",	322,
	"NUM",	323,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"prog : /* empty */",
	"prog : clause_list",
	"clause_list : clause_list",
	"clause_list : clause_list clause",
	"clause_list : /* empty */",
	"clause_lhs : id COLON clause_lhs",
	"clause_lhs : id MINUS COLON clause_lhs",
	"clause_lhs : clause_lhs_list",
	"clause_lhs_list : clause_lhs_list COMMA clause_lhs_element",
	"clause_lhs_list : clause_lhs_element",
	"clause_lhs_element : const LPAREN optarglist RPAREN",
	"clause_lhs_element : DEL const LPAREN optarglist RPAREN",
	"clause_lhs_element : SYMBOL",
	"export_clause : EXPORT arg_fact",
	"export_clause : export_clause COMMA arg_fact",
	"export_clause : EXPORT const LBRACKET optarglist RBRACKET",
	"export_clause : export_clause COMMA const LBRACKET optarglist RBRACKET",
	"clause_left : /* empty */",
	"clause_left : clause_lhs",
	"clause : clause_left clause_rhs",
	"clause : clause_left APPEND rhs_pred_list opt_annotes PERIOD",
	"clause : clause_left DELETE rhs_pred_list opt_annotes PERIOD",
	"clause : clause_left UPDATE rhs_pred_list opt_annotes PERIOD",
	"clause : clause_left ASSIGN rhs_pred_list opt_annotes PERIOD",
	"clause : QUESTION",
	"clause : QUESTION rhs_pred_list PERIOD",
	"clause : START_C_MODULE PERIOD",
	"clause : END_C_MODULE PERIOD",
	"clause : MODULE id PERIOD",
	"clause : END_MODULE PERIOD",
	"clause : export_clause PERIOD",
	"clause : AT SYMBOL SYMBOL opt_adorn_string plus_or_minus PERIOD",
	"clause : AT SYMBOL SYMBOL opt_adorn_string LPAREN optarglist RPAREN LPAREN optarglist RPAREN plus_or_minus PERIOD",
	"clause : AT SYMBOL SYMBOL opt_adorn_string LPAREN optarglist RPAREN plus_or_minus PERIOD",
	"clause : AT SYMBOL SYMBOL opt_adorn_string LPAREN optarglist RPAREN LPAREN optarglist RPAREN simple_arg plus_or_minus PERIOD",
	"clause : AT SYMBOL SYMBOL opt_adorn_string LPAREN optarglist RPAREN simple_arg plus_or_minus PERIOD",
	"clause : AT SYMBOL plus_or_minus PERIOD",
	"clause : PERIOD",
	"clause : error PERIOD",
	"clause : error PERIOD clause",
	"plus_or_minus : PLUS",
	"plus_or_minus : MINUS",
	"plus_or_minus : /* empty */",
	"clause_rhs : MARK rhs_pred_list opt_annotes PERIOD",
	"clause_rhs : PERIOD",
	"opt_annotes : ALIAS",
	"opt_annotes : ALIAS literal_alias sips_or_rule_anno",
	"opt_annotes : /* empty */",
	"rhs_pred_list : rhs_pred_list COMMA rhs_pred",
	"rhs_pred_list : rhs_pred",
	"rhs_pred : pred",
	"rhs_pred : /* empty */",
	"pred : const LPAREN optarglist RPAREN",
	"pred : const",
	"pred : arg relop arg",
	"pred : NOT arg relop arg",
	"pred : NOT const LPAREN optarglist RPAREN",
	"pred : NOT const",
	"pred : CUT",
	"relop : EQUAL",
	"relop : NOTEQUAL",
	"relop : LESS",
	"relop : GREATER",
	"relop : LESSEQUAL",
	"relop : GREATEREQUAL",
	"arglist : arglist COMMA arg",
	"arglist : arg",
	"grouping_list : arg",
	"optarglist : arglist",
	"optarglist : /* empty */",
	"arg : arg_primary",
	"arg : arg PLUS arg",
	"arg : arg MINUS arg",
	"arg : arg STAR arg",
	"arg : arg SLASH arg",
	"arg : arg SLASHSLASH arg",
	"arg : arg LSHIFT arg",
	"arg : arg RSHIFT arg",
	"arg : arg BITXOR arg",
	"arg : arg BITAND arg",
	"arg : arg BITOR arg",
	"arg : BITNOT arg_primary",
	"arg : arg MOD arg",
	"arg : MINUS arg_primary",
	"arg_primary : arg_fact",
	"arg_primary : LPAREN arg RPAREN",
	"simple_arg : const LPAREN optarglist RPAREN",
	"arg_fact : const",
	"arg_fact : NUM",
	"arg_fact : var_arg",
	"arg_fact : UNDERSCORE",
	"arg_fact : DOLLAR",
	"arg_fact : const LPAREN optarglist RPAREN",
	"arg_fact : LBRACKET arglist VBAR arg RBRACKET",
	"arg_fact : LBRACKET optarglist RBRACKET",
	"arg_fact : LESS grouping_list GREATER",
	"arg_fact : /* empty */",
	"arg_fact : LBRACE member_list RBRACE",
	"var_arg : VAR",
	"member_list : member_list COMMA arg_fact",
	"member_list : arg_fact",
	"member_list : /* empty */",
	"const : SYMBOL",
	"literal_alias : LBRACKET",
	"literal_alias : LBRACKET p_idlist RBRACKET",
	"p_id : id",
	"p_idlist : p_idlist COMMA p_id",
	"p_idlist : p_id",
	"p_idlist : /* empty */",
	"sips_or_rule_anno : rule_anno_list",
	"rule_anno_list : rule_anno_list COMMA rule_anno",
	"rule_anno_list : rule_anno",
	"rule_anno_list : /* empty */",
	"rule_anno : anno_name anno_case_details",
	"rule_anno : sips",
	"anno_name : SYMBOL",
	"anno_case : anno_case_name ARROW anno_case_details",
	"anno_case_list : anno_case COMMA anno_case_list",
	"anno_case_list : anno_case",
	"anno_case_name : SYMBOL",
	"anno_case_name : NUM",
	"anno_case_name : VAR",
	"anno_case_name : UNDERSCORE",
	"anno_case_name : const LPAREN optarglist RPAREN",
	"anno_case_name : LBRACKET optarglist RBRACKET",
	"anno_case_details : SYMBOL",
	"anno_case_details : NUM",
	"anno_case_details : VAR",
	"anno_case_details : UNDERSCORE",
	"anno_case_details : const LPAREN optarglist RPAREN",
	"anno_case_details : LBRACKET optarglist RBRACKET",
	"anno_case_details : LBRACKET anno_case_list RBRACKET",
	"sips : SIPS LBRACKET sip_list RBRACKET",
	"sip_list_entry : LBRACKET adorn_string COLON sip RBRACKET",
	"sip_list : sip_list COMMA sip_list_entry",
	"sip_list : sip_list_entry",
	"sip_list : LBRACKET RBRACKET",
	"opt_adorn_string : /* empty */",
	"opt_adorn_string : LBRACKET id RBRACKET",
	"adorn_string : id",
	"sip : sip COMMA arc",
	"sip : arc",
	"arc : LBRACKET arc_idlist RBRACKET ARROW id LPAREN bound_var_list RPAREN",
	"arc : /* empty */",
	"bound_var : VAR",
	"bound_var : /* empty */",
	"bound_var_list : bound_var_list COMMA bound_var",
	"bound_var_list : bound_var",
	"arc_id : id",
	"arc_idlist : arc_idlist COMMA arc_id",
	"arc_idlist : arc_id",
	"id : const",
	"id : VAR",
};
#endif /* YYDEBUG */
#line 1 "/usr/lib/yaccpar"
/*	@(#)yaccpar 1.10 89/04/04 SMI; from S5R3 1.10	*/

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	{ free(yys); free(yyv); return(0); }
#define YYABORT		{ free(yys); free(yyv); return(1); }
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-1000)

/*
** static variables used by the parser
*/
static YYSTYPE *yyv;			/* value stack */
static int *yys;			/* state stack */

static YYSTYPE *yypv;			/* top of value stack */
static int *yyps;			/* top of state stack */

static int yystate;			/* current state */
static int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */

int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */


/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
int
yyparse()
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */
	unsigned yymaxdepth = YYMAXDEPTH;

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yyv = (YYSTYPE*)malloc(yymaxdepth*sizeof(YYSTYPE));
	yys = (int*)malloc(yymaxdepth*sizeof(int));
	if (!yyv || !yys)
	{
		yyerror( "out of memory" );
		return(1);
	}
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

	goto yystack;
	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			(void)printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				(void)printf( "end-of-file\n" );
			else if ( yychar < 0 )
				(void)printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				(void)printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			int yyps_index = (yy_ps - yys);
			int yypv_index = (yy_pv - yyv);
			int yypvt_index = (yypvt - yyv);
			yymaxdepth += YYMAXDEPTH;
			yyv = (YYSTYPE*)realloc((char*)yyv,
				yymaxdepth * sizeof(YYSTYPE));
			yys = (int*)realloc((char*)yys,
				yymaxdepth * sizeof(int));
			if (!yyv || !yys)
			{
				yyerror( "yacc stack overflow" );
				return(1);
			}
			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			(void)printf( "Received token " );
			if ( yychar == 0 )
				(void)printf( "end-of-file\n" );
			else if ( yychar < 0 )
				(void)printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				(void)printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				(void)printf( "Received token " );
				if ( yychar == 0 )
					(void)printf( "end-of-file\n" );
				else if ( yychar < 0 )
					(void)printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					(void)printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
				yynerrs++;
			skip_init:
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						(void)printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					(void)printf( "Error recovery discards " );
					if ( yychar == 0 )
						(void)printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						(void)printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						(void)printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			(void)printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 1:
# line 173 "gram.y"
{
                    exEnv.C_interrupt_raised = 0;
		    parserStruct.init() ;  
                    parserStruct.rules->chain = NULL;
                    parseEnv.print_prompt();
		} break;
case 2:
# line 180 "gram.y"
{
		    parserStruct.rule_list = (struct rule*)
                                              parserStruct.rules->chain;
		} break;
case 3:
# line 187 "gram.y"
{
		    parserStruct.rule_var_names.length = 0;
 		    parserStruct.rhspreds.length = 0;
 		    parserStruct.nested_index = 0;
		    if (parseEnv.C_at_end_module) {
                      // IS THIS NECESSARY ?? - PRAVEEN
		      parserStruct.init();
                      init_collection(parserStruct.rules, 0);
		     }
      		} break;
case 4:
# line 198 "gram.y"
{
                    if (exEnv.C_interrupt_raised != 0) {
		      if (exEnv.C_interrupt_raised == 2) {
			/* happens if there is quit() executed */
			/** exEnv.flush_all_outputs(); **/
			YYACCEPT;
		       }
		      if (exEnv.C_interrupt_raised > 0) {
			fprintf(exEnv.error_file,"CORAL:: Interrupt occurred during execution!:");
			fprintf(exEnv.error_file,"resetting state !\n");
			fflush(exEnv.error_file);
			//abort a consult that is halfway thru
			parseEnv.abort_file();
		       }
		      // else, the user does not want to see more answers to the query, and the
                      // value is -1
		      exEnv.C_interrupt_raised = 0;
		     }

		    if (exEnv.C_do_history_default) parseEnv.handle_history();

                    if (parseEnv.show_prompt) parseEnv.print_prompt();
#ifdef DEBUG
                    if (T_Stack.count) {
		      fprintf(exEnv.error_file, "Warning : non-zero tablestack = %d!\n",
			      T_Stack.count);
		      T_Stack.count = 0;
		    }
#endif
		} break;
case 6:
# line 231 "gram.y"
{
		    struct ClauseName *cname = new ClauseName();
		    cname->name = yypvt[-2].name;
		    cname->negated = 0;
		    cname->next = cur_rule->clause_names;
		    cur_rule->clause_names = cname;
		} break;
case 7:
# line 239 "gram.y"
{
		    struct ClauseName *cname = new ClauseName();
		    cname->name = yypvt[-3].name;
		    cname->negated = 1;
		    cname->next = cur_rule->clause_names;
		    cur_rule->clause_names = cname;
		} break;
case 8:
# line 247 "gram.y"
{
		} break;
case 9:
# line 252 "gram.y"
{
		} break;
case 10:
# line 255 "gram.y"
{
		} break;
case 11:
# line 260 "gram.y"
{
		    cur_rule->head = AllocLiteral(parserStruct, yypvt[-3].name, 
					 parserStruct.cur_arg_chain->count);
                    if (complexRelation)
		      complexRelation--;
		    pop_arg_chain(parserStruct, cur_rule->head->args);
		    cur_rule->clause_names = NULL;
		} break;
case 12:
# line 270 "gram.y"
{
		    // Used to be 
		    // cur_rule->head =
		    Literal *lit = 
		    	 AllocLiteral(parserStruct, yypvt[-3].name,
					   parserStruct.cur_arg_chain->count);
                    if (complexRelation)
		      complexRelation--;
		    lit->negated = 1;
		    pop_arg_chain(parserStruct, lit->args);
		    cur_rule->clause_names = NULL;

		    if (parseEnv.in_query_loop && cur_rule->head == NULL) {
			cur_rule->head = lit;
		    }
		    else {
			if (cur_rule->head_deletes) {
			    cur_rule->head_deletes =
			      (Literal **) realloc((char *)cur_rule->head_deletes,
			         sizeof(Literal*) *
			         (++cur_rule->head_deletes_count) );
			}
			else {
			    cur_rule->head_deletes =
				    (Literal **)malloc(sizeof(Literal*));
			    cur_rule->head_deletes_count++;
			}
			cur_rule->head_deletes[cur_rule->head_deletes_count-1]=lit;
		    }
                    COR_set_eager_eval(parserStruct.CurModule, 0);
		} break;
case 13:
# line 303 "gram.y"
{
		    cur_rule->head = AllocLiteral(parserStruct, yypvt[-0].name,0);
                    if (complexRelation)
		      complexRelation--;
		    cur_rule->clause_names = NULL;
		} break;
case 14:
# line 312 "gram.y"
{
		    AddExportInfo(parserStruct, (FuncArg*)yypvt[-0].arg);
		} break;
case 15:
# line 316 "gram.y"
{
		    AddExportInfo(parserStruct, (FuncArg*)yypvt[-0].arg);
		} break;
case 16:
# line 320 "gram.y"
{
                  AddExportInfo(parserStruct, 
				(FuncArg*)(create_functor(parserStruct, yypvt[-3].name)));
		} break;
case 17:
# line 325 "gram.y"
{
                  AddExportInfo(parserStruct, 
				(FuncArg*)(create_functor(parserStruct, yypvt[-3].name)));
		} break;
case 18:
# line 332 "gram.y"
{ parserStruct.lhs_flag = 1; 
	       cur_rule = copy_rule(NULL);
	       cur_rule->line_number = parseEnv.C_linenum;
	     } break;
case 19:
# line 337 "gram.y"
{ // yyval.pred = yypvt[-0].pred; 
	       parserStruct.lhs_flag = 0;
	       C_num_head_arith_lits = parserStruct.rhspreds.length;
	     } break;
case 20:
# line 344 "gram.y"
{
		    if (parseEnv.in_query_loop) {
		      parserStruct.assign_func(FactFunction);
		      parserStruct.cur_rule = cur_rule;
		      if (exEnv.C_exec_mode == COR_DOING_IMPERATIVE)
			YYACCEPT;
		      parserStruct.execute();
		      parserStruct.reset(0);
		    }
		    else {
		      /* transfer information from parserStruct to cur_rule
		       * and insert cur_rule into the parserStruct's rulelist
		       */
		      complete_rule(cur_rule, parserStruct);
		    }
		} break;
case 21:
# line 362 "gram.y"
{
                    parserStruct.assign_func(AppendFunction);
                    parserStruct.cur_rule = cur_rule;

                    if (exEnv.C_exec_mode == COR_DOING_IMPERATIVE)
		      YYACCEPT;
                    parserStruct.execute();
                    delete parserStruct.cur_rule; 
                    /* Better not delete the head predicate. */
		    parserStruct.cur_rule = NULL;
		} break;
case 22:
# line 375 "gram.y"
{
                    parserStruct.assign_func(DeleteFunction);
                    parserStruct.cur_rule = cur_rule;
                    if (exEnv.C_exec_mode == COR_DOING_IMPERATIVE)
		      YYACCEPT;
                    parserStruct.execute();
                    delete parserStruct.cur_rule; 
                    /* Better not delete the head predicate. */
		    parserStruct.cur_rule = NULL;
		} break;
case 23:
# line 387 "gram.y"
{
                  fprintf(exEnv.error_file, "Sorry : Updates not implemented yet\n");
                } break;
case 24:
# line 392 "gram.y"
{
                    parserStruct.assign_func(AssignFunction);
                    parserStruct.cur_rule = cur_rule;
                    if (exEnv.C_exec_mode == COR_DOING_IMPERATIVE)
		      YYACCEPT;
                    parserStruct.execute();
                    delete parserStruct.cur_rule; 
                    /* Better not delete the head predicate. */
		    parserStruct.cur_rule = NULL;
                } break;
case 25:
# line 404 "gram.y"
{
                    cur_rule = copy_rule(NULL);
	            cur_rule->line_number = parseEnv.C_linenum;
		    cur_rule->clause_names = NULL;
                } break;
case 26:
# line 410 "gram.y"
{
                    parserStruct.assign_func(QueryFunction);
                    parserStruct.cur_rule = cur_rule;
                    if (exEnv.C_exec_mode == COR_DOING_IMPERATIVE)
		      YYACCEPT;
                    parserStruct.execute();
		    parserStruct.reset(1);
		} break;
case 27:
# line 419 "gram.y"
{
                    parseEnv.c_module_separator = 0;
                } break;
case 28:
# line 424 "gram.y"
{
                    parseEnv.c_module_separator = 1;
                    if (exEnv.C_exec_mode == COR_DOING_IMPERATIVE)
		      YYACCEPT;
                } break;
case 29:
# line 431 "gram.y"
{
                    parserStruct.init() ;
                    init_collection(parserStruct.rules, 1);
                    parseEnv.C_at_end_module = 0;
		    parseEnv.in_query_loop = 0 ;
		    parserStruct.CurModule.name = yypvt[-1].name;
		    strcpy(parseEnv.prompt_name, parseEnv.prompt);
		    strcat(parseEnv.prompt_name, "*");
		    parseEnv.prompt = parseEnv.prompt_name;	      
		} break;
case 30:
# line 443 "gram.y"
{
		    parseEnv.C_at_end_module = 1;

		    parserStruct.rule_list = (struct rule*)
                                              parserStruct.rules->chain;
                    parserStruct.assign_func(EndModuleFunction);
                    parserStruct.cur_rule = cur_rule;

		    if (exEnv.C_exec_mode == COR_DOING_INTERPRET) {
                      parserStruct.execute();
		      init_collection(parserStruct.rules, 0);
		      // reinitialize CurrModuleInfo 
		      CurrModuleInfo->init_flags();
		      parseEnv.in_query_loop = 1 ;

		      if (!strcmp(SymbolString(CurDB->name), "default_db"))
			parseEnv.prompt = CORAL_PROMPT ;
		      else {
			strcpy(parseEnv.prompt_name, SymbolString(CurDB->name));
			strcat(parseEnv.prompt_name, CORAL_PROMPT);
			parseEnv.prompt = parseEnv.prompt_name;
		      }
		      parseEnv.print_prompt();
		    }
                    else if (exEnv.C_exec_mode == COR_DOING_IMPERATIVE) {
		      parseEnv.in_query_loop = 1;
		      YYACCEPT;
		    }
                    else { 
		      // magic or factoring or existential optimization
		      YYACCEPT;
		    }
                  } break;
case 32:
# line 480 "gram.y"
{
                    ArgList *al1 = ArgList::New(1);
                    if ((Arg_t *)(yypvt[-2].name))
                      (*al1)[0] = (Arg_t *)(yypvt[-2].name);
                    else al1->set_count(0);
		    if (yypvt[-4].name == AllowedAdornSymbol) {
			add_allowed_adornment(parserStruct, yypvt[-3].name, al1 );
		    }
                    // NOTE :: Currently this does not give multiset
                    // semantics. It merely acts as do_not_check_subsum.
                    // The user should not use this annotation in its 
                    // current state.
		    else if (yypvt[-4].name == MultisetSymbol) {
			add_multiset_annotation(parserStruct, yypvt[-3].name, al1, 0);
		    }
		    else if (yypvt[-4].name == CheckSubsumSymbol) {
			add_multiset_annotation(parserStruct, yypvt[-3].name, al1, yypvt[-1].integer);
		    }
/***
		    else if ($2 == DiskResidentSymbol) {
			add_diskrel_annotation(parserStruct, $3, al1);
		    }
***/
		    else if (yypvt[-4].name == IndexDeltaSymbol) {
			add_index_delta_annotation(parserStruct, yypvt[-3].name, al1 );
		    }
		    else CORAL_error(COR_BAD_ANNO, SymbolString(yypvt[-4].name),
				     "yyparse:anno3");

		} break;
case 33:
# line 512 "gram.y"
{
		    ArgList *al2 = ArgList::New(parserStruct.cur_arg_chain->count);
		    pop_arg_chain(parserStruct, *al2);
		    ArgList *al1 = ArgList::New(parserStruct.cur_arg_chain->count);
		    pop_arg_chain(parserStruct, *al1);
		    if ( yypvt[-10].name == MakeIndexSymbol) {
		      add_make_index_annotation(
			parserStruct.make_index_annotations, yypvt[-9].name,yypvt[-8].name, al1, al2);
		    }
                    else if ( yypvt[-10].name == ChoiceSymbol) {
                      fprintf(exEnv.error_file,
                        "ERROR:  choice no longer supported %s\n",
                        " -- use aggregate selection `any' instead");
                    }
                    else
		      CORAL_error( COR_BAD_ANNO,SymbolString(yypvt[-10].name),"yyparse:anno1");
		} break;
case 34:
# line 531 "gram.y"
{
		    ArgList *al1 = ArgList::New(parserStruct.cur_arg_chain->count);
		    pop_arg_chain(parserStruct, *al1);
		    if ( yypvt[-7].name == MakeIndexSymbol) {
		      add_make_index_annotation(
			parserStruct.make_index_annotations,yypvt[-6].name,yypvt[-5].name, al1, NULL);
		    }
		    else if (yypvt[-7].name == DiskResidentSymbol) {
			add_diskrel_annotation(parserStruct, yypvt[-6].name, yypvt[-5].name, al1);
		    }
		    else CORAL_error(COR_BAD_ANNO, 
				     SymbolString(yypvt[-7].name),"yyparse:anno2");

		} break;
case 35:
# line 548 "gram.y"
{
		    Arg_t * op_arg = yypvt[-2].arg;
		    ArgList *al2 = ArgList::New(parserStruct.cur_arg_chain->
						count);
		    pop_arg_chain(parserStruct, *al2);

		    ArgList *al1 = ArgList::New(parserStruct.cur_arg_chain->
						count);
		    pop_arg_chain(parserStruct, *al1);

		    /* Should have some error checking to see if 
				predicate name is correct! */

		    if ( yypvt[-11].name == AggSelectionSymbol) {
			add_agg_sel_annotation(parserStruct,
					yypvt[-10].name, yypvt[-9].name, al1, al2, op_arg);
			COR_set_eager_eval(parserStruct.CurModule, 0);
		    }
		    else CORAL_error(COR_BAD_ANNO, SymbolString(yypvt[-11].name),
				     "yyparse:anno4");

		} break;
case 36:
# line 573 "gram.y"
{
                  ArgList *al1 = ArgList::New(parserStruct.cur_arg_chain->count);
                  pop_arg_chain(parserStruct, *al1);
                  if ( yypvt[-8].name == PrioritizeSymbol) {
                      add_prioritize_annotation(parserStruct, yypvt[-7].name, yypvt[-6].name,
                              al1, yypvt[-2].arg);
                  }
                  else CORAL_error(COR_BAD_ANNO, SymbolString(yypvt[-8].name), fname);
                } break;
case 37:
# line 584 "gram.y"
{
		    if ( yypvt[-2].name == SaveModuleSymbol)
		        COR_set_save_module(parserStruct.CurModule, yypvt[-1].integer);
		    else if ( yypvt[-2].name == SupplementaryMagicSymbol)
			COR_set_supplementary_magic(parserStruct.CurModule, yypvt[-1].integer);
		    else if ( yypvt[-2].name == OrdinaryMagicSymbol)
			COR_set_ordinary_magic(parserStruct.CurModule, yypvt[-1].integer);
		    else if ( yypvt[-2].name == SupMagicIndexingSymbol)
			COR_set_sup_magic_indexing(parserStruct.CurModule, yypvt[-1].integer);
		    else if ( (yypvt[-2].name == NoMagicSymbol) && yypvt[-1].integer) 
                        COR_set_no_magic(parserStruct.CurModule);
                    else if (yypvt[-2].name == ExistOptSymbol)
                        COR_set_exist_opt(parserStruct.CurModule, yypvt[-1].integer);
                    else if (yypvt[-2].name == UseFactoringSymbol)
		      COR_set_use_factoring(parserStruct.CurModule, yypvt[-1].integer);
                    else if (yypvt[-2].name == UseOrdSearchSymbol)
                        COR_set_use_ordsearch(parserStruct.CurModule, yypvt[-1].integer);
                    else if (yypvt[-2].name == EagerEvalSymbol)
                        COR_set_eager_eval(parserStruct.CurModule, yypvt[-1].integer);
		    else if (yypvt[-2].name == UsePipeliningSymbol)
                        COR_set_pipelining(parserStruct.CurModule, yypvt[-1].integer);
		    else if ( yypvt[-2].name == IndexDeltaSymbol)
                        COR_set_index_deltas(parserStruct.CurModule, yypvt[-1].integer);
                    else if ( yypvt[-2].name == PredicateSNSymbol)
                        COR_set_predicate_seminaive(parserStruct.CurModule, yypvt[-1].integer);
		    else if (yypvt[-2].name == MultisetSymbol)
                        COR_set_multisets(parserStruct.CurModule, yypvt[-1].integer);
		    else if (yypvt[-2].name == CheckSubsumSymbol)
                        COR_set_check_subsum(parserStruct.CurModule, yypvt[-1].integer);
		    else if (yypvt[-2].name == SingleSccSymbol)
                        COR_set_single_scc(parserStruct.CurModule, yypvt[-1].integer);
		    else if (yypvt[-2].name == SingleAnswerSymbol)
                        COR_set_single_answer(parserStruct.CurModule, yypvt[-1].integer);
		    else if (yypvt[-2].name == ConvertFunctionsSymbol)
                        COR_set_convert_functions(parserStruct.CurModule, yypvt[-1].integer);
                    else if (yypvt[-2].name == MonotonicSymbol)
                        COR_set_monotonic(parserStruct.CurModule, yypvt[-1].integer);
		    else if (yypvt[-2].name == ReturnUnifySymbol)
                        COR_set_return_unify(parserStruct.CurModule, yypvt[-1].integer);
                    else if (yypvt[-2].name == NoRewritingSymbol)
                        COR_set_rewriting(parserStruct.CurModule, !(yypvt[-1].integer));
                    else if (yypvt[-2].name == NoPreProcessingSymbol)
                        COR_set_preprocessing(parserStruct.CurModule, !(yypvt[-1].integer));
                    else if (yypvt[-2].name == NonGroundFactsSymbol)
                        COR_set_non_ground_facts(parserStruct.CurModule, yypvt[-1].integer);
                    else if (yypvt[-2].name == DiskResidentSymbol)
                        COR_set_disk_resident(parserStruct.CurModule, yypvt[-1].integer);
		    else  CORAL_error(COR_BAD_ANNO, SymbolString(yypvt[-2].name),fname);

		} break;
case 38:
# line 635 "gram.y"
{} break;
case 39:
# line 638 "gram.y"
{
		    CORAL_error(COR_BAD_SYNTAX, NULL, fname);
		    yyerrok ;
		    parserStruct.rule_var_names.length = 0;
 		    parserStruct.rhspreds.length = 0;
 		    parserStruct.nested_index = 0;
                    //parserStruct.parameters = new parameter_chain;
		    parseEnv.print_prompt();
		} break;
case 40:
# line 647 "gram.y"
{} break;
case 41:
# line 651 "gram.y"
{ yyval.integer = 1;} break;
case 42:
# line 652 "gram.y"
{ yyval.integer = 0; } break;
case 43:
# line 653 "gram.y"
{ yyval.integer = 1;} break;
case 44:
# line 657 "gram.y"
{
                } break;
case 45:
# line 660 "gram.y"
{
		    cur_rule->annotations = NULL;
		    cur_rule->sips    = NULL;
		} break;
case 46:
# line 666 "gram.y"
{cur_rule->sips = NULL;} break;
case 47:
# line 668 "gram.y"
{ 
		   yyval.rule_anno = NULL;
		} break;
case 48:
# line 671 "gram.y"
{ 
		    yyval.rule_anno = NULL; 
		    cur_rule->annotations = NULL; 
		    cur_rule->sips = NULL;
		} break;
case 51:
# line 684 "gram.y"
{
		    add_to_array(&parserStruct.rhspreds, (int)yypvt[-0].pred);
		} break;
case 53:
# line 691 "gram.y"
{
		    yyval.pred = AllocLiteral(parserStruct, yypvt[-3].name,
				      parserStruct.cur_arg_chain->count);
		    pop_arg_chain(parserStruct, yyval.pred->args);
		} break;
case 54:
# line 697 "gram.y"
{
                    yyval.pred = AllocLiteral(parserStruct, yypvt[-0].name, 0);
                } break;
case 55:
# line 701 "gram.y"
{
		    yyval.pred = AllocLiteral(parserStruct, yypvt[-1].name, 2);
		    arg_vector(yyval.pred->args)[0] = yypvt[-2].arg;
		    arg_vector(yyval.pred->args)[1] = yypvt[-0].arg;
		} break;
case 56:
# line 707 "gram.y"
{
		    yyval.pred = AllocLiteral(parserStruct, yypvt[-1].name, 2);
		    yyval.pred->negated = 1;
		    arg_vector(yyval.pred->args)[0] = yypvt[-2].arg;
		    arg_vector(yyval.pred->args)[1] = yypvt[-0].arg;
		} break;
case 57:
# line 714 "gram.y"
{
		    yyval.pred = AllocLiteral(parserStruct, yypvt[-3].name, 
				      parserStruct.cur_arg_chain->count);
		    yyval.pred->negated = 1;
		    pop_arg_chain(parserStruct, yyval.pred->args);
		} break;
case 58:
# line 721 "gram.y"
{
		    yyval.pred = AllocLiteral(parserStruct, yypvt[-0].name, 0);
		    yyval.pred->negated = 1;
		} break;
case 59:
# line 726 "gram.y"
{
		    yyval.pred = AllocLiteral(parserStruct, CutSymbol, 0);
		} break;
case 60:
# line 731 "gram.y"
{ yyval.name = EquOpSymbol; } break;
case 61:
# line 732 "gram.y"
{ yyval.name = NeqOpSymbol; } break;
case 62:
# line 733 "gram.y"
{ yyval.name = LssOpSymbol; } break;
case 63:
# line 734 "gram.y"
{ yyval.name = GrtOpSymbol; } break;
case 64:
# line 735 "gram.y"
{ yyval.name = LeqOpSymbol; } break;
case 65:
# line 736 "gram.y"
{ yyval.name = GeqOpSymbol; } break;
case 66:
# line 742 "gram.y"
{
		    if (parserStruct.CurModule.ConvertFunctions &&
			(yypvt[-0].arg)->kindof() == COR_NUM_CONST &&
			    ((NumArg *) (yypvt[-0].arg))->num_kindof() == COR_ARITH_EXPR) {
			// need to create the equality literal 
			Arg_t *temp_var = NULL;
			push_arg_chain(parserStruct);
			append_arg(parserStruct, yypvt[-0].arg);
			temp_var = pull_out_arith_expr(parserStruct);
			    // the above function also does a pop_arg_chain

			append_arg(parserStruct, temp_var);
		    }
		    else {
		        append_arg(parserStruct, yypvt[-0].arg);
		    }
		} break;
case 67:
# line 761 "gram.y"
{
		    push_arg_chain(parserStruct);
		    if (parserStruct.CurModule.ConvertFunctions &&
			(yypvt[-0].arg)->kindof() == COR_NUM_CONST &&
			    ((NumArg *) (yypvt[-0].arg))->num_kindof() == COR_ARITH_EXPR) {
			// need to create the equality literal 
			Arg_t *temp_var = NULL;
			push_arg_chain(parserStruct);
			append_arg(parserStruct, yypvt[-0].arg);
			temp_var = pull_out_arith_expr(parserStruct);
			// the above function also does a pop_arg_chain

			append_arg(parserStruct, temp_var);
		    }
		    else {
		        append_arg(parserStruct, yypvt[-0].arg);
		    }
		} break;
case 68:
# line 783 "gram.y"
{
                    push_arg_chain(parserStruct);
                    append_arg(parserStruct, yypvt[-0].arg);
               } break;
case 70:
# line 792 "gram.y"
{
		    push_arg_chain(parserStruct);
		} break;
case 72:
# line 798 "gram.y"
{
		    yyval.arg = new ExprArg(AddOpSymbol, yypvt[-2].arg, yypvt[-0].arg);
		} break;
case 73:
# line 802 "gram.y"
{
		    yyval.arg = new ExprArg(SubOpSymbol, yypvt[-2].arg, yypvt[-0].arg);
		} break;
case 74:
# line 806 "gram.y"
{
		    yyval.arg = new ExprArg(MulOpSymbol, yypvt[-2].arg, yypvt[-0].arg);
		} break;
case 75:
# line 810 "gram.y"
{
		    yyval.arg = new ExprArg(DivOpSymbol, yypvt[-2].arg, yypvt[-0].arg);
		} break;
case 76:
# line 814 "gram.y"
{
		    yyval.arg = new ExprArg(IDivOpSymbol, yypvt[-2].arg, yypvt[-0].arg);
		} break;
case 77:
# line 819 "gram.y"
{
	            yyval.arg = new ExprArg(LShiftOpSymbol, yypvt[-2].arg, yypvt[-0].arg);
                } break;
case 78:
# line 823 "gram.y"
{
	            yyval.arg = new ExprArg(RShiftOpSymbol, yypvt[-2].arg, yypvt[-0].arg);
                } break;
case 79:
# line 827 "gram.y"
{
	            yyval.arg = new ExprArg(BitxorOpSymbol, yypvt[-2].arg, yypvt[-0].arg);
                } break;
case 80:
# line 831 "gram.y"
{
	            yyval.arg = new ExprArg(BitandOpSymbol, yypvt[-2].arg, yypvt[-0].arg);
                } break;
case 81:
# line 836 "gram.y"
{
                    yyval.arg = new ExprArg(BitorOpSymbol, yypvt[-2].arg, yypvt[-0].arg);
                } break;
case 82:
# line 841 "gram.y"
{
                    yyval.arg = new ExprArg(BitnotOpSymbol, yypvt[-0].arg);
                } break;
case 83:
# line 846 "gram.y"
{
	            yyval.arg = new ExprArg(ModOpSymbol, yypvt[-2].arg, yypvt[-0].arg);
                } break;
case 84:
# line 852 "gram.y"
{
		    if ((yypvt[-0].arg)->kindof() == COR_NUM_CONST) {
		      if (((NumArg *)yypvt[-0].arg)->num_kindof() == COR_INTEGER)
			yyval.arg = new NumArg(-((NumArg *)yypvt[-0].arg)->i_val);
		      else 
			yyval.arg = new NumArg(-((NumArg *)yypvt[-0].arg)->d_val);
                        // This delete is okay because NUM_CONSTs are not shared.
                        delete ((NumArg *)yypvt[-0].arg);
		    }
		    else {
			yyval.arg = new ExprArg(SubOpSymbol, yypvt[-0].arg);
		    }
		} break;
case 86:
# line 868 "gram.y"
{
		    yyval.arg = yypvt[-1].arg;
		} break;
case 87:
# line 873 "gram.y"
{
                   yyval.arg = create_functor(parserStruct, yypvt[-3].name);
               } break;
case 88:
# line 877 "gram.y"
{ yyval.arg = (Arg_t*)yypvt[-0].name; } break;
case 90:
# line 879 "gram.y"
{ yyval.arg = yypvt[-0].arg; } break;
case 91:
# line 880 "gram.y"
{ 

                // NOTE : this is a kludge ! Unification with dont care terms
                // is tricky, so instead we force the DontCareSymbol to be
                // treated each time as a distinct variable. The parser
                // NEVER generates  TheDontCareArg !! The scanner NEVER
                // returns UNDERSCORE !! Instead it returns VAR for "_"
                   yyval.arg = &TheDontCareArg; fprintf(stderr, "DONT_CARE_ARG!!\n"); 
                } break;
case 92:
# line 890 "gram.y"
{
                  //yyval.arg = &TheParameterArg;
                  yyval.arg = TheParameterArg;
                } break;
case 93:
# line 895 "gram.y"
{
                  yyval.arg = create_functor(parserStruct, yypvt[-3].name);
		} break;
case 94:
# line 899 "gram.y"
{
		    yyval.arg  = create_list(parserStruct, yypvt[-1].arg);
		} break;
case 95:
# line 903 "gram.y"
{
		    yyval.arg = create_list(parserStruct, NilArg);
		} break;
case 96:
# line 907 "gram.y"
{
                  if (parserStruct.lhs_flag) {
                    complexRelation++ ;
		    if (exEnv.dbg_aggregates) 
                      fprintf(exEnv.error_file,"nested att found complex relation %d\n",
			      complexRelation);
                    yyval.arg = create_multi_grouping(parserStruct) ;
                  }
                  else {
                    CORAL_error( COR_GROUPING_ON_RHS,NULL, fname);
                    YYERROR;
                  }
		} break;
case 97:
# line 920 "gram.y"
{ push_cur_set(parserStruct, create_nested_multiset()); } break;
case 98:
# line 922 "gram.y"
{ yyval.arg = parserStruct.cur_set->info;
                  complexRelation++ ;
                  if (exEnv.dbg_aggregates)
                    fprintf(exEnv.error_file,"nested att found complex relation %d\n",
                          complexRelation);
                  pop_cur_set(parserStruct);
                } break;
case 99:
# line 931 "gram.y"
{ yyval.arg = new VarArg(yypvt[-0].name, rule_var_enter(parserStruct, yypvt[-0].name)); } break;
case 100:
# line 934 "gram.y"
{ insert_cur_set(parserStruct, yypvt[-0].arg); } break;
case 101:
# line 935 "gram.y"
{ insert_cur_set(parserStruct, yypvt[-0].arg); } break;
case 104:
# line 942 "gram.y"
{ parserStruct.sip_var_names.length=0; } break;
case 105:
# line 944 "gram.y"
{
                  yyval.alias_list = NULL;
		} break;
case 106:
# line 950 "gram.y"
{ add_to_array(&parserStruct.sip_var_names, (int)yypvt[-0].name); } break;
case 110:
# line 956 "gram.y"
{
			yyval.rule_anno = NULL;
		} break;
case 111:
# line 963 "gram.y"
{
			if (yypvt[-0].rule_anno != NULL)
			    yyval.rule_anno = link_rule_anno(yypvt[-0].rule_anno,yypvt[-2].rule_anno);
			else yyval.rule_anno = yypvt[-2].rule_anno;
		} break;
case 112:
# line 969 "gram.y"
{
			yyval.rule_anno = link_rule_anno(yypvt[-0].rule_anno,NULL);
		} break;
case 113:
# line 973 "gram.y"
{
			yyval.rule_anno = NULL;
		} break;
case 114:
# line 979 "gram.y"
{
			yyval.rule_anno = make_anno(yypvt[-1].name,yypvt[-0].anno_case_details);
		} break;
case 115:
# line 983 "gram.y"
{
			yyval.rule_anno = NULL;
		} break;
case 117:
# line 992 "gram.y"
{
			yyval.anno_case = make_anno_case(yypvt[-2].anno_case_name,yypvt[-0].anno_case_details);
		} break;
case 118:
# line 998 "gram.y"
{
			yyval.anno_case = link_anno_case_list(yypvt[-0].anno_case, yypvt[-2].anno_case);
		} break;
case 119:
# line 1002 "gram.y"
{
			yyval.anno_case = link_anno_case_list(yypvt[-0].anno_case,NULL);
		} break;
case 120:
# line 1008 "gram.y"
{
			yyval.anno_case_name = make_anno_case_name(yypvt[-0].name);
		} break;
case 121:
# line 1012 "gram.y"
{
			yyval.anno_case_name = make_anno_case_name(yypvt[-0].arg);
		} break;
case 122:
# line 1016 "gram.y"
{
			VarArg *v= new VarArg(yypvt[-0].name, rule_var_enter(parserStruct, yypvt[-0].name)) ;
			yyval.anno_case_name = make_anno_case_name(v);
		} break;
case 123:
# line 1021 "gram.y"
{
			yyval.anno_case_name = make_anno_case_name(&TheDontCareArg);
		} break;
case 124:
# line 1025 "gram.y"
{
			yyval.anno_case_name = make_anno_case_name(create_functor(parserStruct, yypvt[-3].name));
		} break;
case 125:
# line 1029 "gram.y"
{
			yyval.anno_case_name = make_anno_case_name(create_list(parserStruct, NilArg));
		} break;
case 126:
# line 1035 "gram.y"
{
			yyval.anno_case_details = make_anno_case_details(yypvt[-0].name);
		} break;
case 127:
# line 1039 "gram.y"
{
			yyval.anno_case_details = make_anno_case_details(yypvt[-0].arg);
		} break;
case 128:
# line 1043 "gram.y"
{
			VarArg *v= new VarArg(yypvt[-0].name, rule_var_enter(parserStruct, yypvt[-0].name)) ; 
			yyval.anno_case_details = make_anno_case_details(v);
		} break;
case 129:
# line 1048 "gram.y"
{ 
			yyval.anno_case_details = make_anno_case_details(&TheDontCareArg); 
		} break;
case 130:
# line 1052 "gram.y"
{
			yyval.anno_case_details = make_anno_case_details(create_functor(parserStruct, yypvt[-3].name));
		} break;
case 131:
# line 1056 "gram.y"
{
			yyval.anno_case_details = make_anno_case_details(create_list(parserStruct, NilArg));
		} break;
case 132:
# line 1060 "gram.y"
{
			yyval.anno_case_details = make_anno_case_details(yypvt[-1].anno_case);
		} break;
case 133:
# line 1066 "gram.y"
{cur_rule->sips = yypvt[-1].sips;} break;
case 134:
# line 1073 "gram.y"
{
		    yyval.sips = new sips;
		    {   char *ap;
		    	int i;
		    	/* ??? Check for possible length errors */
		    	yyval.sips->adorn.setlen((int) SymbolLength(yypvt[-3].name));
		    	for(i=0,ap = SymbolString(yypvt[-3].name); i < SymbolLength(yypvt[-3].name);
						i++, ap++) 
				if ( *ap == 'b') yyval.sips->adorn.set(i);
		    }
		    yyval.sips->sip_list = yypvt[-1].sip;
		    yyval.sips->next = NULL;
		} break;
case 135:
# line 1088 "gram.y"
{
		    yyval.sips = yypvt[-0].sips;
		    yypvt[-0].sips->next = yypvt[-2].sips;

		} break;
case 136:
# line 1094 "gram.y"
{
		    yyval.sips = yypvt[-0].sips;
		    yypvt[-0].sips->next = NULL;
		} break;
case 137:
# line 1098 "gram.y"
{ yyval.sips = NULL; } break;
case 138:
# line 1102 "gram.y"
{yyval.name = NULL;} break;
case 139:
# line 1104 "gram.y"
{yyval.name = yypvt[-1].name;} break;
case 140:
# line 1108 "gram.y"
{
			yyval.name = yypvt[-0].name;
		} break;
case 141:
# line 1115 "gram.y"
{
		    yyval.sip = yypvt[-2].sip;
		    yyval.sip->next = yypvt[-0].sip;
		} break;
case 142:
# line 1120 "gram.y"
{
		    yyval.sip = yypvt[-0].sip;
		} break;
case 143:
# line 1126 "gram.y"
{
		    yyval.sip = new sip();
		    yyval.sip->tail = CurTail;
		    yyval.sip->bound_vars = CurBoundVars;
		    yyval.sip->head = sip_var_lookup(parserStruct, yypvt[-3].name);
                    yyval.sip->next = NULL;
		    CurTail.clear();
		    CurBoundVars.clear();
		} break;
case 144:
# line 1136 "gram.y"
{
		    yyval.sip = NULL;
		} break;
case 145:
# line 1141 "gram.y"
{
		    CurBoundVars.set(rule_var_lookup(parserStruct, yypvt[-0].name));
		} break;
case 149:
# line 1151 "gram.y"
{
		    CurTail.set(sip_var_lookup(parserStruct, yypvt[-0].name));
		} break;
	}
	goto yystack;		/* reset registers in driver code */
}
