/************************************************************************
 ========================================================================
 CORAL 
 (c)  Copyright R. Ramakrishnan and The CORAL Group, 
 University of Wisconsin at Madison.
 (1992) All Rights Reserved.
 Version 0.1
 ========================================================================



 ------------------------------------------------------------------------
 CORAL Version 0.1
 RESEARCH SOFTWARE DISCLAIMER -------------------------------------------
 ------------------------------------------------------------------------

    As unestablished, research software, this program is provided free of 
    charge on an "as is" basis without warranty of any kind, either 
    express or implied.  Acceptance and use of this program constitutes 
    the user's understanding that (s)he will have no recourse for any 
    actual or consequential damages, including, but not limited to, 
    lost profits or savings, arising out of the use of or inability to 
    use this program.  

 ------------------------------------------------------------------------
 USER AGREEMENT ---------------------------------------------------------
 ------------------------------------------------------------------------

     BY ACCEPTANCE AND USE OF THIS EXPERIMENTAL PROGRAM
     THE USER AGREES TO THE FOLLOWING:

     a.  This program is provided free of charge for the user's personal, 
	 non-commercial, experimental use.

     b.  All title, ownership and rights to this program and any copies 
         remain with the copyright holder, irrespective of the ownership 
	 of the media on which the program resides.

     c.  The user is permitted to create derivative works to this program.  
         However, all copies of the program and its derivative works must
         contain the CORAL copyright notice, the UNESTABLISHED SOFTWARE 
         DISCLAIMER and this USER AGREEMENT.

     d.  The user understands and agrees that this program and any 
         derivative works are to be used solely for experimental purposes 
	 and are not to be sold or commercially exploited in any manner 
	 WITHOUT EXPRESS WRITTEN PERMISSION.

     e.  We request that the user supply us with a copy of any changes, 
         enhancements, or derivative works which the user may create,
	 with the user's permission to redistribute it.
	 Copies of such material should be sent to:  CORAL@CS.WISC.EDU

-------------------------------------------------------------------------
*************************************************************************/

extern char *copy_string (char *);

void handle_export_declaration(scan_input *, handle_export *, mystring *);
int get_optional_pointer(scan_input *); 
char * handle_name_declaration(scan_input *); 
void handle_arglist_declaration(scan_input *, handle_export *, mystring *);
kind handle_type_declaration(scan_input *, mystring *);
void output_export_code(scan_input *, handle_export *, mystring *, char *, mystring *);
void output_init_export(scan_input *, char *, char *);
struct vars_list *lookup_tuple_var(char *, struct vars_list *);
struct vars_list *lookup_relation_var(char *, struct vars_list *);
char *gen_tuple_stmt(struct vars_list *);
char *new_name();
void gen_arg(struct arg_list *);
int handle_embedded_token(scan_input *, int, int, char *);
void handle_make_tuple(scan_input *, int,int,char *);
char * output_make_tuple(scan_input *, int , struct arg_list *, char *, int, int);
void output_call_dummy(scan_input *, char *);
//void handle_coral_code(scan_input *, char *, char *, infoStruct&);
void handle_coral_code(scan_input *, infoStruct&);
void generate_initialization_code(char *fn_name, infoStruct&);


char *subs_str(char *, char *, int, int);
void gen_tuple_arg_stmt(FILE *, int, struct arg_list *);
extern char *concat1(char *, int);
void close(scan_input *, mystring *);

/* list of args if available */
struct arg_list { 
	
	token *arg_type;
	struct arg_list *next;
};


/* list of tuple variables */
struct vars_list {
	char *string;		//name
	int type;		// pointer or not
	int level;		// nesting level of defn
	int arg_count;
	arg_list *args;
	struct vars_list *next;
};
