/************************************************************************
 ========================================================================
 CORAL 
 (c)  Copyright R. Ramakrishnan and The CORAL Group, 
 University of Wisconsin at Madison.
 (1992) All Rights Reserved.
 Version 0.1
 ========================================================================



 ------------------------------------------------------------------------
 CORAL Version 0.1
 RESEARCH SOFTWARE DISCLAIMER -------------------------------------------
 ------------------------------------------------------------------------

    As unestablished, research software, this program is provided free of 
    charge on an "as is" basis without warranty of any kind, either 
    express or implied.  Acceptance and use of this program constitutes 
    the user's understanding that (s)he will have no recourse for any 
    actual or consequential damages, including, but not limited to, 
    lost profits or savings, arising out of the use of or inability to 
    use this program.  

 ------------------------------------------------------------------------
 USER AGREEMENT ---------------------------------------------------------
 ------------------------------------------------------------------------

     BY ACCEPTANCE AND USE OF THIS EXPERIMENTAL PROGRAM
     THE USER AGREES TO THE FOLLOWING:

     a.  This program is provided free of charge for the user's personal, 
	 non-commercial, experimental use.

     b.  All title, ownership and rights to this program and any copies 
         remain with the copyright holder, irrespective of the ownership 
	 of the media on which the program resides.

     c.  The user is permitted to create derivative works to this program.  
         However, all copies of the program and its derivative works must
         contain the CORAL copyright notice, the UNESTABLISHED SOFTWARE 
         DISCLAIMER and this USER AGREEMENT.

     d.  The user understands and agrees that this program and any 
         derivative works are to be used solely for experimental purposes 
	 and are not to be sold or commercially exploited in any manner 
	 WITHOUT EXPRESS WRITTEN PERMISSION.

     e.  We request that the user supply us with a copy of any changes, 
         enhancements, or derivative works which the user may create,
	 with the user's permission to redistribute it.
	 Copies of such material should be sent to:  CORAL@CS.WISC.EDU

-------------------------------------------------------------------------
*************************************************************************/

#if 0
length of element is power of two longs (currently only 1 or 2)
HashNone(*(long*)element) => element[0] == 0
Deleted => element[0] == 1
map->argBuf[*element]
must adjust for reserved HashNone and Deleted
#endif

#if defined(HASH_ELEMENT_LOG) && defined(HASH_LENGTH_LOG)
#define HASH_USE_MASK
#endif

    register index, step;
    register HASH_ELEMENT_TYPE *element;
#ifdef HASH_DELETED
    HASH_ELEMENT_TYPE *avail;
#endif
#ifdef HASH_USE_MASK
    int mask;
#else
    int limit;
#endif
    index = HASH_TO_INDEX(hash);
    element = (HASH_ELEMENT_TYPE*)((char*)HASH_DATA + index);
    if (HASH_NULL(element)) return (HASH_ELEMENT_TYPE*)element;
#ifdef HASH_DELETED
    avail = NULL;
    if (HASH_DELETED(element)) avail = element;
    else
#endif
    if (HASH_EQUAL(element, arg)) return (HASH_ELEMENT_TYPE *)element;
    step = HASH_TO_STEP(hash);
#ifdef HASH_USE_MASK
    mask = (1 << ((HASH_LENGTH_LOG) + (HASH_ELEMENT_LOG))) - 1;
#else
    limit = HASH_SIZE * HASH_ELEMENT;
#endif
    for (;;)
      {
	index += step;
#ifdef HASH_USE_MASK
	index &= mask;
#else
	if (index >= limit) index -= limit;
#endif
	element = (HASH_ELEMENT_TYPE*)((char*)HASH_DATA + index);
	if (HASH_NULL(element)) {
#ifdef HASH_DELETED
	    if (avail) element = avail;
#endif
	    return (HASH_ELEMENT_TYPE *)element;
	}
#ifdef HASH_DELETED
	if (HASH_DELETED(element)) {
	    if (!avail) avail = element;
	    else if (avail == element) return (HASH_ELEMENT_TYPE *)element;
	}
	else
#endif
        if (HASH_EQUAL(element, arg)) return (HASH_ELEMENT_TYPE *)element;
      }
